/*
 * Copyright (c) 2011-2014 BlackBerry Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import bb.cascades 1.3
import bb.data 1.0
import bb.system 1.2
import bb.cascades.pickers 1.0


        Page {
            id: pgSeznam
            property string sdatum;
            property string jmeno;
            titleBar: TitleBar {
                title: qsTr("Ann Events") + Retranslate.onLocaleOrLanguageChanged
                appearance: TitleBarAppearance.Branded
            
            }     
            Container {
                ScrollView {
            id: swCall
            visible: true
            Container {
                        property real margins: ui.du(3)
                        
                        
                        topPadding: margins
                        leftPadding: margins
                        rightPadding: margins
                        bottomPadding: margins
                        
                                                
                        DropDown {
                            id: folderField
                            
                            title: qsTr ("Store in calendar:") + Retranslate.onLanguageChanged
                            
                            onSelectedValueChanged: {
                                _calendar.eventEditor.folderId = selectedValue.folderId
                                _calendar.eventEditor.accountId = selectedValue.accountId
                            }
                        }
                        DropDown {
                            id: ddStaty
                            title:qsTr ("Choose country:") + Retranslate.onLanguageChanged                             

                            Option {text: "Czech republic"}
                            Option {text: "Slovak republic"}
                            Option {text: "Netherlands"}
                            Option {text: "United States"}
                            Option {text: "China"}
                            selectedIndex:0 
                            onSelectedIndexChanged: {
                                if (selectedIndex == 0) {lv_svatky.dataModel.source = "calendars/anniv_cz.xml"};
                                if (selectedIndex == 1) {lv_svatky.dataModel.source = "calendars/anniv_sk.xml"};
                                if (selectedIndex == 2) {lv_svatky.dataModel.source = "calendars/anniv_nl.xml"};
                                if (selectedIndex == 3) {lv_svatky.dataModel.source = "calendars/anniv_us.xml"};
                                if (selectedIndex == 4) {lv_svatky.dataModel.source = "calendars/anniv_cn.xml"};
                                                            }
                        }
                        
                        Divider {
                        
                        }
                        DropDown {
                            id: ddRok
                            title:qsTr ("Choose year:") + Retranslate.onLanguageChanged                             
                            
                            Option {text: "2016"}
                            Option {text: "2017"}
                            Option {text: "2018"}
                            Option {text: "2019"}
                            Option {text: "2020"}
                            Option {text: "2021"}
                            Option {text: "2022"}
                            
                            selectedIndex:0 
                            }
                            Divider {
                            
                            }
                        
                        
                        Container {
                            layout: StackLayout {
                                orientation: LayoutOrientation.LeftToRight
                            
                            }
                            horizontalAlignment: HorizontalAlignment.Center
                            Button {
                                id: btEvent
                                text: qsTr("Create anniversaries events") + Retranslate.onLanguageChanged 
                                onClicked: {
                                    senddialog.show();
                                }
                                horizontalAlignment: HorizontalAlignment.Center
                                color: Color.DarkGreen
                            
                            }
                            
                        }
                        
                        Label {
                               text: qsTr ("Anniversaries list:") + Retranslate.onLanguageChanged
                        }
                        ListView {
                            id: lv_svatky
                            
                            dataModel: XmlDataModel {
                                source: "calendars/anniv_cz.xml"
                            
                            }
                            listItemComponents: [
                                
                                ListItemComponent {
                                    type: "listItem"
                                    
                                    StandardListItem {
                                        description: ListItemData.title
                                        status: ListItemData.status
                                    }
                                }
                            ]
                                                        
                            topMargin: 6.0
                            topPadding: 6.0
                            bottomPadding: 6.0
                            bottomMargin: 6.0
                          onSelectionChanged: {
                                        var selectedItem = dataModel.data(indexPath);
                                        sdatum = selectedItem.title;
                                        jmeno = selectedItem.status;
                                       }
                }
                
                        
            }

            }   
                attachedObjects: [
                
                    ComponentDefinition {
                        id: emptyOption
                        Option {}
                    },
                    SystemDialog {
                        id: senddialog
                        title: qsTr("Confirmation") + Retranslate.onLocaleOrLanguageChanged
                        body: qsTr("Create events for all anniversaries?") + Retranslate.onLocaleOrLanguageChanged+" ["+ddRok.selectedOption.text+"]"
                        onFinished: {
                            if (senddialog.result == SystemUiResult.ConfirmButtonSelection) 
                            {
                                btEvent.enabled=false;
                                prubehDialog.show();
                                for (var i=0; i<lv_svatky.dataModel.childCount(0); i++) 
                                {
                                    
                                    lv_svatky.select([i], true);
                                    var rok=parseInt(ddRok.selectedOption.text);
                                    var mesic=parseInt(sdatum.substr(3,2),10)-1;
                                    var den=parseInt(sdatum.substr(0,2),10);
                                    var datum = new Date(rok, mesic, den, 0,0,0,0);
                                    //label
                                    _calendar.eventEditor.subject = jmeno;
                                    _calendar.eventEditor.startTime = datum;
                                    var datum = new Date(rok, mesic, den+1, 0,0,0,0);
                                    _calendar.eventEditor.endTime = datum;
                                    _calendar.eventEditor.allDay = true;
                                    _calendar.eventEditor.folderId = folderField.selectedValue.folderId
                                    _calendar.eventEditor.accountId = folderField.selectedValue.accountId
                                    _calendar.eventEditor.saveEvent()
                                    lv_svatky.select([i], false);
                                    
                                } 
                                prubehDialog.destroy();
                                app.showSuccessMessage(qsTr("Calendar items for anniversaries were created") + Retranslate.onLanguageChanged)
                                app.save("CalendarAccount", folderField.selectedIndex);
                            }
                        
                        }
                    },
                    Sheet {
                        id: myReg
                        
                        content: Page {
                            
                            titleBar: TitleBar {
                                title: "Registration";
                                appearance: TitleBarAppearance.Branded
                            
                            }
                            actions: [
                                ActionItem {
                                    title: qsTr("Close app") + Retranslate.onLocaleOrLanguageChanged
                                    imageSource: "asset:///ic_home.png"
                                    ActionBar.placement: ActionBarPlacement.Signature
                                    
                                    // When this action is selected, close
                                    // the sheet
                                    onTriggered: {
                                        myReg.close();
                                        Application.quit();
                                    }
                                }
                            ]
                            ScrollView {
                                
                                Container {
                                    property real margins: ui.du(3)
                                    
                                    
                                    topPadding: margins
                                    leftPadding: margins
                                    rightPadding: margins
                                    bottomPadding: margins
                                    Label {
                                        text:qsTr("Before further using the app, a small registration fee must be paid.")
                                        multiline: true
                                    }
                                    Label {
                                        text:qsTr("This allows us future development a improving our app. Thank you for understanding.")
                                        multiline: true
                                    }
                                    Label {
                                        text:qsTr("Please follow kindly these simple steps:")
                                        multiline: true
                                    }
                                    Label {
                                        text:qsTr("1. Click Generate code button and send displayed code to yamaco@yamaco.cz")
                                        multiline: true
                                    }
                                    Label {
                                        text:qsTr("2. Click Payment button and make a payment of USD 1 (minimum)")
                                        multiline: true
                                    }
                                    Label {
                                        text:qsTr("3. Enter the code which we'll send you back")
                                        multiline: true
                                    }
                                    Label {
                                        text:qsTr("That's all. Thank you so much for your support.")
                                        multiline: true
                                    }
                                    Button {
                                        
                                        preferredWidth: 80.0
                                        text: qsTr("Generate code")
                                        onClicked: {
                                            lbReg.text=getRandomInt(10000000,90000000);
                                            app.save("RegIn", lbReg.text);
                                        }
                                        rightMargin: 10.0
                                    
                                    
                                    }
                                    Label {
                                        id: lbReg
                                        text:qsTr("")
                                    
                                    }
                                    Button {
                                        
                                        preferredWidth: 80.0
                                        text: qsTr("Payment")
                                        onClicked: {
                                            donate.trigger("bb.action.OPEN")
                                        }
                                        rightMargin: 10.0
                                    
                                    
                                    }
                                    Label {
                                        text:qsTr("If you received the registratin code from us, please enter it here and click Register Button:")
                                        multiline: true
                                    }
                                    TextField {
                                        id: tfRegCode
                                        inputMode: TextFieldInputMode.NumbersAndPunctuation
                                    
                                    }
                                    Button {
                                        
                                        preferredWidth: 80.0
                                        text: qsTr("Register")
                                        onClicked: {
                                            if (tfRegCode.text==app.read("RegIn", "")*2-999)
                                            {dlgRegOk.show();app.save("RegOut", "OK");} else 
                                            {dlgRegNo.show()}   
                                        }
                                        rightMargin: 10.0
                                    
                                    
                                    }
                                
                                
                                }
                            } // end of Container
                        
                        
                        }
                    
                    },
                    Sheet {
                        id: mySettings
                        content: Page {
                            titleBar: TitleBar {
                                title: qsTr("Settings") + Retranslate.onLocaleOrLanguageChanged
                                appearance: TitleBarAppearance.Branded
                            
                            }
                            actions: [
                                ActionItem {
                                    title: qsTr("Back") + Retranslate.onLocaleOrLanguageChanged
                                    imageSource: "asset:///ic_home.png"
                                    ActionBar.placement: ActionBarPlacement.Signature
                                    
                                    // When this action is selected, close
                                    // the sheet
                                    onTriggered: {
                                        if (tbTheme.checked == true) {
                                            Settings.saveValueFor("theme", "dark");
                                        } else {
                                            Settings.saveValueFor("theme", "bright");
                                        };
                                        
                                        mySettings.close();
                                    }
                                }
                            ]
                            Container {
                        id: cnNastaveni

                        property real margins: ui.du(3)
                                
                                
                                topPadding: margins
                                leftPadding: margins
                                rightPadding: margins
                                bottomPadding: margins
                        ScrollView {
                            Container {
                                Divider {
                                
                                }
                                
                                Container {
                                    verticalAlignment: VerticalAlignment.Top
                                    layout: DockLayout {
                                    
                                    }
                                    horizontalAlignment: HorizontalAlignment.Fill
                                    Label {
                                        text: qsTr("Dark theme") + Retranslate.onLocaleOrLanguageChanged
                                        verticalAlignment: VerticalAlignment.Top
                                    
                                    }
                                    ToggleButton {
                                        id: tbTheme
                                        verticalAlignment: VerticalAlignment.Top
                                        horizontalAlignment: HorizontalAlignment.Right
                                    
                                    }
                                
                                }
                                
                                
                            }

                        }

                    }
                    onCreationCompleted: {
                        if (Settings.getValueFor("theme", "bright") == "dark") {
                            tbTheme.checked = true
                        } else {
                            tbTheme.checked = false
                        }
                        if (app.read("RegOut", "")=="")
                        {myReg.open()};
                        
                    }
                }
            }
        ]

    }
    attachedObjects: [
        
        SystemDialog {
            id: aboutDialog
            title: "Info"
            body: "(c) YAMACO Software 2016-2019 \n \n web: www.yamaco.cz \n email: yamaco@yamaco.cz"
            cancelButton.label: ""
        },
        SystemProgressDialog {
            id: prubehDialog
            autoUpdateEnabled: true
            activityIndicatorVisible: true
            cancelButton.enabled: false
            customButton.enabled: false
            confirmButton.enabled: false
            dismissAutomatically: true
            rememberMeText: ""
            title: qsTr("Creating events (up 3 minutes)...") + Retranslate.onLocaleOrLanguageChanged
        },
        Invocation {
            id: invoke
            query: InvokeQuery {
                mimeType: "text/html"
                uri: "http://appworld.blackberry.com/webstore/vendor/91027/?lang=en&countrycode=CZ"
                invokeActionId: "bb.action.OPEN"
            }
        },
        Invocation {
            id: donate
            query: InvokeQuery {
                mimeType: "text/html"
                uri: "https://yamaco.cz/blackberry-apps-donation.html"
                invokeActionId: "bb.action.OPEN"
            }
        
        },
        SystemDialog {
            id: dlgRegOk
            title: "Info"
            body: "Registration was successful. Thank you and restart the app please."
            cancelButton.label: ""
        }   
        ,
        SystemDialog {
            id: dlgRegNo
            title: "Info"
            body: "Wrong registration code."
            cancelButton.label: ""
        } 

    ]
    
    
    actions: [

        ActionItem {
            title: qsTr("Settings") + Retranslate.onLanguageChanged
            imageSource: "asset:///ic_settings.png"
            ActionBar.placement: ActionBarPlacement.Signature

            onTriggered: {
                mySettings.open();

            }

        },
        ActionItem {
            title: qsTr("Info") + Retranslate.onLanguageChanged
            imageSource: "asset:///ic_info.png"
            ActionBar.placement: ActionBarPlacement.InOverflow

            onTriggered: {
                aboutDialog.show()
            }

        },
        ActionItem {
            title: qsTr("More apps") + Retranslate.onLanguageChanged
            imageSource: "asset:///ic_select_more.png"
            ActionBar.placement: ActionBarPlacement.InOverflow
            onTriggered: {
                invoke.trigger("bb.action.OPEN")
            }

        }
        

    ]
    
    onCreationCompleted: {
        _calendar.eventEditor.initializeFolderDropDown(folderField);
        folderField.selectedIndex = app.read("CalendarAccount", 0);
    }

    function getRandomInt(min, max) {
        min = Math.ceil(min);
        max = Math.floor(max);
        return Math.floor(Math.random() * (max - min)) + min;
    }
    
}

